﻿init python:
    class combination_lock_class:
        def __init__(self, number):
            self.number = number
            self.digits = []
            for i in str(number):
                self.digits.append([0, int(i)])
            self.is_locked = True
            self.x = 0
        def change(self, index, amount):
            self.digits[index][0] += amount
            if self.digits[index][0] > 9:
                self.digits[index][0] = 0
            elif self.digits[index][0] < 0:
                self.digits[index][0] = 9
        def check(self):
            for i in self.digits:
                if not i[0] == i[1]:
                    renpy.play("combination lock/locked.ogg", "sound")
                    self.x = 10
                    break
                    
            else:
                self.is_locked = False
                self.x = 100
                renpy.play("combination lock/unlock.ogg", "sound")
                Show("combination_lock_open")()
        def ret(self):
            self.x = 0
screen combination_lock(n):
    modal True
    default g = combination_lock_class(n)
    add "combination lock/body.png" align .5,.5
    hbox:
        align .5,.5
        for n,i in enumerate(g.digits):
            fixed:
                fit_first True
                add "combination lock/{}.png".format(i[0])
                button:
                    background None yoffset 55
                    action Function(g.change, n, 1)
                    activate_sound "combination lock/rotate_down.ogg"
                button:
                    background None yoffset -55
                    action Function(g.change, n, -1)
                    activate_sound "combination lock/rotate_up.ogg"
        button:
            yoffset -2
            at combination_lock_trans(g.x)
            align .5,.5
            add "combination lock/button.png"
            action Function(g.check)

    if g.is_locked and g.x:
        timer .1 repeat True action Function(g.ret)

screen combination_lock_open():
    timer 1 action Hide("combination_lock_open"), Return()

transform combination_lock_trans(x):
    ease .2 xoffset x
image bg leather = "combination lock/bg.webp"
label lock_example:
    show bg leather
    "here's a hint, it starts with 9 and ends with 2"
    call screen combination_lock(902)
    "You did it, it's open."
    "now let's try something a little harder."
    "And this time no tips!"
    window hide
    call screen combination_lock(12345678)